// Generated by Create API
// https://github.com/CreateAPI/CreateAPI
//
// swift-format-ignore-file

import Foundation

public struct TerritoryAvailability: Codable, Equatable, Identifiable, Sendable {
    public var type: `Type`
    public var id: String
    public var attributes: Attributes?
    public var relationships: Relationships?
    public var links: ResourceLinks?

    public enum `Type`: String, CaseIterable, Codable, Sendable {
        case territoryAvailabilities
    }

    public struct Attributes: Codable, Equatable, Sendable {
        public var isAvailable: Bool?
        public var releaseDate: String?
        public var isPreOrderEnabled: Bool?
        public var preOrderPublishDate: String?
        public var contentStatuses: [ContentStatus]?

        public enum ContentStatus: String, CaseIterable, Codable, Sendable {
            case available = "AVAILABLE"
            case availableForPreorderOnDate = "AVAILABLE_FOR_PREORDER_ON_DATE"
            case processingToNotAvailable = "PROCESSING_TO_NOT_AVAILABLE"
            case processingToAvailable = "PROCESSING_TO_AVAILABLE"
            case processingToPreOrder = "PROCESSING_TO_PRE_ORDER"
            case availableForSaleUnreleasedApp = "AVAILABLE_FOR_SALE_UNRELEASED_APP"
            case preorderOnUnreleasedApp = "PREORDER_ON_UNRELEASED_APP"
            case availableForPreorder = "AVAILABLE_FOR_PREORDER"
            case missingRating = "MISSING_RATING"
            case cannotSellRestrictedRating = "CANNOT_SELL_RESTRICTED_RATING"
            case brazilRequiredTaxID = "BRAZIL_REQUIRED_TAX_ID"
            case missingGrn = "MISSING_GRN"
            case unverifiedGrn = "UNVERIFIED_GRN"
            case cannotSellSeventeenPlusApps = "CANNOT_SELL_SEVENTEEN_PLUS_APPS"
            case cannotSellSexuallyExplicit = "CANNOT_SELL_SEXUALLY_EXPLICIT"
            case cannotSellNonIosGames = "CANNOT_SELL_NON_IOS_GAMES"
            case cannotSellSeventeenPlusGames = "CANNOT_SELL_SEVENTEEN_PLUS_GAMES"
            case cannotSellFrequentIntenseGambling = "CANNOT_SELL_FREQUENT_INTENSE_GAMBLING"
            case cannotSellCasino = "CANNOT_SELL_CASINO"
            case cannotSellCasinoWithoutGrac = "CANNOT_SELL_CASINO_WITHOUT_GRAC"
            case cannotSellCasinoWithoutAgeVerification = "CANNOT_SELL_CASINO_WITHOUT_AGE_VERIFICATION"
            case cannotSellFrequentIntenseAlcoholTobaccoDrugs = "CANNOT_SELL_FREQUENT_INTENSE_ALCOHOL_TOBACCO_DRUGS"
            case cannotSellFrequentIntenseViolence = "CANNOT_SELL_FREQUENT_INTENSE_VIOLENCE"
            case cannotSellFrequentIntenseSexualContentNudity = "CANNOT_SELL_FREQUENT_INTENSE_SEXUAL_CONTENT_NUDITY"
            case cannotSellInfrequentMildAlcoholTobaccoDrugs = "CANNOT_SELL_INFREQUENT_MILD_ALCOHOL_TOBACCO_DRUGS"
            case cannotSellInfrequentMildSexualContentNudity = "CANNOT_SELL_INFREQUENT_MILD_SEXUAL_CONTENT_NUDITY"
            case cannotSellAdultOnly = "CANNOT_SELL_ADULT_ONLY"
            case cannotSellFrequentIntense = "CANNOT_SELL_FREQUENT_INTENSE"
            case cannotSellFrequentIntenseWithoutGrac = "CANNOT_SELL_FREQUENT_INTENSE_WITHOUT_GRAC"
            case cannotSellGamblingContests = "CANNOT_SELL_GAMBLING_CONTESTS"
            case cannotSellGambling = "CANNOT_SELL_GAMBLING"
            case cannotSellContests = "CANNOT_SELL_CONTESTS"
            case cannotSell = "CANNOT_SELL"
        }

        public init(isAvailable: Bool? = nil, releaseDate: String? = nil, isPreOrderEnabled: Bool? = nil, preOrderPublishDate: String? = nil, contentStatuses: [ContentStatus]? = nil) {
            self.isAvailable = isAvailable
            self.releaseDate = releaseDate
            self.isPreOrderEnabled = isPreOrderEnabled
            self.preOrderPublishDate = preOrderPublishDate
            self.contentStatuses = contentStatuses
        }

        private enum CodingKeys: String, CodingKey {
            case isAvailable = "available"
            case releaseDate
            case isPreOrderEnabled = "preOrderEnabled"
            case preOrderPublishDate
            case contentStatuses
        }
    }

    public struct Relationships: Codable, Equatable, Sendable {
        public var territory: Territory?

        public struct Territory: Codable, Equatable, Sendable {
            public var links: Links?
            public var data: Data?

            public struct Links: Codable, Equatable, Sendable {
                public var this: URL?
                public var related: URL?

                public init(this: URL? = nil, related: URL? = nil) {
                    self.this = this
                    self.related = related
                }

                private enum CodingKeys: String, CodingKey {
                    case this = "self"
                    case related
                }
            }

            public struct Data: Codable, Equatable, Identifiable, Sendable {
                public var type: `Type`
                public var id: String

                public enum `Type`: String, CaseIterable, Codable, Sendable {
                    case territories
                }

                public init(type: `Type` = .territories, id: String) {
                    self.type = type
                    self.id = id
                }
            }

            public init(links: Links? = nil, data: Data? = nil) {
                self.links = links
                self.data = data
            }
        }

        public init(territory: Territory? = nil) {
            self.territory = territory
        }
    }

    public init(type: `Type` = .territoryAvailabilities, id: String, attributes: Attributes? = nil, relationships: Relationships? = nil, links: ResourceLinks? = nil) {
        self.type = type
        self.id = id
        self.attributes = attributes
        self.relationships = relationships
        self.links = links
    }
}
