// Generated by Create API
// https://github.com/CreateAPI/CreateAPI
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1 {
    public var appCategories: AppCategories {
        AppCategories(path: path + "/appCategories")
    }

    public struct AppCategories {
        /// Path: `/v1/appCategories`
        public let path: String

        public func get(filterPlatforms: [FilterPlatforms]? = nil, isExistsParent: Bool? = nil, fieldsAppCategories: [FieldsAppCategories]? = nil, limit: Int? = nil, include: [Include]? = nil, limitSubcategories: Int? = nil) -> Request<_Specification.AppCategoriesResponse> {
            Request(path: path, method: "GET", query: makeGetQuery(filterPlatforms, isExistsParent, fieldsAppCategories, limit, include, limitSubcategories), id: "appCategories-get_collection")
        }

        private func makeGetQuery(_ filterPlatforms: [FilterPlatforms]?, _ isExistsParent: Bool?, _ fieldsAppCategories: [FieldsAppCategories]?, _ limit: Int?, _ include: [Include]?, _ limitSubcategories: Int?) -> [(String, String?)] {
            let encoder = URLQueryEncoder(explode: false)
            encoder.encode(filterPlatforms, forKey: "filter[platforms]")
            encoder.encode(isExistsParent, forKey: "exists[parent]")
            encoder.encode(fieldsAppCategories, forKey: "fields[appCategories]")
            encoder.encode(limit, forKey: "limit")
            encoder.encode(include, forKey: "include")
            encoder.encode(limitSubcategories, forKey: "limit[subcategories]")
            return encoder.items
        }

        public enum FilterPlatforms: String, CaseIterable, Codable, Sendable {
            case ios = "IOS"
            case macOs = "MAC_OS"
            case tvOs = "TV_OS"
            case visionOs = "VISION_OS"
        }

        public enum FieldsAppCategories: String, CaseIterable, Codable, Sendable {
            case parent
            case platforms
            case subcategories
        }

        public enum Include: String, CaseIterable, Codable, Sendable {
            case parent
            case subcategories
        }
    }
}
