// Generated by Create API
// https://github.com/CreateAPI/CreateAPI
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.AppEventLocalizations {
    public func id(_ id: String) -> WithID {
        WithID(path: "\(path)/\(id)")
    }

    public struct WithID {
        /// Path: `/v1/appEventLocalizations/{id}`
        public let path: String

        public func get(fieldsAppEventLocalizations: [FieldsAppEventLocalizations]? = nil, include: [Include]? = nil, fieldsAppEventScreenshots: [FieldsAppEventScreenshots]? = nil, fieldsAppEventVideoClips: [FieldsAppEventVideoClips]? = nil, limitAppEventScreenshots: Int? = nil, limitAppEventVideoClips: Int? = nil) -> Request<_Specification.AppEventLocalizationResponse> {
            Request(path: path, method: "GET", query: makeGetQuery(fieldsAppEventLocalizations, include, fieldsAppEventScreenshots, fieldsAppEventVideoClips, limitAppEventScreenshots, limitAppEventVideoClips), id: "appEventLocalizations-get_instance")
        }

        private func makeGetQuery(_ fieldsAppEventLocalizations: [FieldsAppEventLocalizations]?, _ include: [Include]?, _ fieldsAppEventScreenshots: [FieldsAppEventScreenshots]?, _ fieldsAppEventVideoClips: [FieldsAppEventVideoClips]?, _ limitAppEventScreenshots: Int?, _ limitAppEventVideoClips: Int?) -> [(String, String?)] {
            let encoder = URLQueryEncoder(explode: false)
            encoder.encode(fieldsAppEventLocalizations, forKey: "fields[appEventLocalizations]")
            encoder.encode(include, forKey: "include")
            encoder.encode(fieldsAppEventScreenshots, forKey: "fields[appEventScreenshots]")
            encoder.encode(fieldsAppEventVideoClips, forKey: "fields[appEventVideoClips]")
            encoder.encode(limitAppEventScreenshots, forKey: "limit[appEventScreenshots]")
            encoder.encode(limitAppEventVideoClips, forKey: "limit[appEventVideoClips]")
            return encoder.items
        }

        public enum FieldsAppEventLocalizations: String, CaseIterable, Codable, Sendable {
            case appEvent
            case appEventScreenshots
            case appEventVideoClips
            case locale
            case longDescription
            case name
            case shortDescription
        }

        public enum Include: String, CaseIterable, Codable, Sendable {
            case appEvent
            case appEventScreenshots
            case appEventVideoClips
        }

        public enum FieldsAppEventScreenshots: String, CaseIterable, Codable, Sendable {
            case appEventAssetType
            case appEventLocalization
            case assetDeliveryState
            case assetToken
            case fileName
            case fileSize
            case imageAsset
            case uploadOperations
            case uploaded
        }

        public enum FieldsAppEventVideoClips: String, CaseIterable, Codable, Sendable {
            case appEventAssetType
            case appEventLocalization
            case assetDeliveryState
            case fileName
            case fileSize
            case previewFrameTimeCode
            case previewImage
            case uploadOperations
            case uploaded
            case videoURL = "videoUrl"
        }

        public func patch(_ body: _Specification.AppEventLocalizationUpdateRequest) -> Request<_Specification.AppEventLocalizationResponse> {
            Request(path: path, method: "PATCH", body: body, id: "appEventLocalizations-update_instance")
        }

        public var delete: Request<Void> {
            Request(path: path, method: "DELETE", id: "appEventLocalizations-delete_instance")
        }
    }
}
