// Generated by Create API
// https://github.com/CreateAPI/CreateAPI
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.CiBuildActions {
    public func id(_ id: String) -> WithID {
        WithID(path: "\(path)/\(id)")
    }

    public struct WithID {
        /// Path: `/v1/ciBuildActions/{id}`
        public let path: String

        public func get(fieldsCiBuildActions: [FieldsCiBuildActions]? = nil, include: [Include]? = nil, fieldsCiIssues: [FieldsCiIssues]? = nil, fieldsCiBuildRuns: [FieldsCiBuildRuns]? = nil, fieldsCiTestResults: [FieldsCiTestResults]? = nil, fieldsCiArtifacts: [FieldsCiArtifacts]? = nil) -> Request<_Specification.CiBuildActionResponse> {
            Request(path: path, method: "GET", query: makeGetQuery(fieldsCiBuildActions, include, fieldsCiIssues, fieldsCiBuildRuns, fieldsCiTestResults, fieldsCiArtifacts), id: "ciBuildActions-get_instance")
        }

        private func makeGetQuery(_ fieldsCiBuildActions: [FieldsCiBuildActions]?, _ include: [Include]?, _ fieldsCiIssues: [FieldsCiIssues]?, _ fieldsCiBuildRuns: [FieldsCiBuildRuns]?, _ fieldsCiTestResults: [FieldsCiTestResults]?, _ fieldsCiArtifacts: [FieldsCiArtifacts]?) -> [(String, String?)] {
            let encoder = URLQueryEncoder(explode: false)
            encoder.encode(fieldsCiBuildActions, forKey: "fields[ciBuildActions]")
            encoder.encode(include, forKey: "include")
            encoder.encode(fieldsCiIssues, forKey: "fields[ciIssues]")
            encoder.encode(fieldsCiBuildRuns, forKey: "fields[ciBuildRuns]")
            encoder.encode(fieldsCiTestResults, forKey: "fields[ciTestResults]")
            encoder.encode(fieldsCiArtifacts, forKey: "fields[ciArtifacts]")
            return encoder.items
        }

        public enum FieldsCiBuildActions: String, CaseIterable, Codable, Sendable {
            case actionType
            case artifacts
            case buildRun
            case completionStatus
            case executionProgress
            case finishedDate
            case isRequiredToPass
            case issueCounts
            case issues
            case name
            case startedDate
            case testResults
        }

        public enum Include: String, CaseIterable, Codable, Sendable {
            case buildRun
        }

        public enum FieldsCiIssues: String, CaseIterable, Codable, Sendable {
            case category
            case fileSource
            case issueType
            case message
        }

        public enum FieldsCiBuildRuns: String, CaseIterable, Codable, Sendable {
            case actions
            case buildRun
            case builds
            case cancelReason
            case clean
            case completionStatus
            case createdDate
            case destinationBranch
            case destinationCommit
            case executionProgress
            case finishedDate
            case isPullRequestBuild
            case issueCounts
            case number
            case product
            case pullRequest
            case sourceBranchOrTag
            case sourceCommit
            case startReason
            case startedDate
            case workflow
        }

        public enum FieldsCiTestResults: String, CaseIterable, Codable, Sendable {
            case className
            case destinationTestResults
            case fileSource
            case message
            case name
            case status
        }

        public enum FieldsCiArtifacts: String, CaseIterable, Codable, Sendable {
            case downloadURL = "downloadUrl"
            case fileName
            case fileSize
            case fileType
        }
    }
}
